import nltk
nltk.data.path.append("D:\\PycharmProjects\\AILearn\\NLTK")
from nltk.corpus import movie_reviews
from nltk.classify import NaiveBayesClassifier
from nltk.classify.util import accuracy as nacc

# Tạo hàm để xay dựng một dictionary dựa trên những từ được nhập vào và trả lại giá trị:
def extract_features(words):
    return dict((word,True) for word in words)
#Tạo hàm main và load dữ liệu những đánh giá phim đã được gắn nhãn:
if __name__=="__main__":
    fileids_pos=movie_reviews.fileids('pos')
    fileids_neg=movie_reviews.fileids('neg')
    # Tách những features từ những ddanhs giá và dán nhãn nó
    features_pos=[(extract_features(movie_reviews.words(fileids=[f])),'Có vẻ thích') for f in fileids_pos]
    features_neg = [(extract_features(movie_reviews.words(fileids=[f])), 'Hình như méo thích') for f in fileids_neg]
    #Tạo tỉ lệ chia
    threshold=0.8
    num_pos=int(threshold*len(features_pos))
    num_neg=int(threshold*len(features_neg))
    # Tách các vector đặc trưng để train và test
    features_train=features_pos[:num_pos]+features_neg[:num_neg]
    features_test=features_pos[num_pos:]+features_neg[num_neg:]
    # Sử dụng Naive Bayes để tạo bộ phân loại và tính độ chính xác
    classifier=NaiveBayesClassifier.train(features_train)
    print("Độ chính xác của bộ phân loại: ",round(nacc(classifier,features_test)*100,2),"%")
    N=15
    # In top 15 những từ có giá trị thông tin nhất
    """for i,item in enumerate(classifier.most_informative_features()):
        print(str(i+1)+'.'+item[0])
        if i==N-1:
            break"""
    # Tạo một vài review ví dụ sử dụng để test
    input_reviews = ['The costumes in this movie were great',
                     'I think the story was terrible and the characters were very weak',
                     'People say that the director of the movie is amazing',
                     'This is such an idiotic movie. I will not recommend it to anyone.']
    # Tạo vòng lặp để dự đoán từng kết quả
    for review in input_reviews:
        print("Đánh giá: ",review)
        probabilities=classifier.prob_classify(extract_features(review))
        predict_sentiment=probabilities.max()
        # in kết quả
        print("Dự đoán cảm xúc:",predict_sentiment)
        # Dự đoán tỉ lệ chính xác
        print("Độ chính xác",round(probabilities.prob(predict_sentiment),2))